/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	scheme "quark.netapp.io/volume-controller/pkg/client/clientset/versioned/scheme"
)

// NodevolSetsGetter has a method to return a NodevolSetInterface.
// A group's client should implement this interface.
type NodevolSetsGetter interface {
	NodevolSets(namespace string) NodevolSetInterface
}

// NodevolSetInterface has methods to work with NodevolSet resources.
type NodevolSetInterface interface {
	Create(ctx context.Context, nodevolSet *v1alpha1.NodevolSet, opts v1.CreateOptions) (*v1alpha1.NodevolSet, error)
	Update(ctx context.Context, nodevolSet *v1alpha1.NodevolSet, opts v1.UpdateOptions) (*v1alpha1.NodevolSet, error)
	UpdateStatus(ctx context.Context, nodevolSet *v1alpha1.NodevolSet, opts v1.UpdateOptions) (*v1alpha1.NodevolSet, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.NodevolSet, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.NodevolSetList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NodevolSet, err error)
	NodevolSetExpansion
}

// nodevolSets implements NodevolSetInterface
type nodevolSets struct {
	client rest.Interface
	ns     string
}

// newNodevolSets returns a NodevolSets
func newNodevolSets(c *QuarkV1alpha1Client, namespace string) *nodevolSets {
	return &nodevolSets{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the nodevolSet, and returns the corresponding nodevolSet object, and an error if there is any.
func (c *nodevolSets) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.NodevolSet, err error) {
	result = &v1alpha1.NodevolSet{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("nodevolsets").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of NodevolSets that match those selectors.
func (c *nodevolSets) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NodevolSetList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.NodevolSetList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("nodevolsets").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested nodevolSets.
func (c *nodevolSets) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("nodevolsets").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a nodevolSet and creates it.  Returns the server's representation of the nodevolSet, and an error, if there is any.
func (c *nodevolSets) Create(ctx context.Context, nodevolSet *v1alpha1.NodevolSet, opts v1.CreateOptions) (result *v1alpha1.NodevolSet, err error) {
	result = &v1alpha1.NodevolSet{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("nodevolsets").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(nodevolSet).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a nodevolSet and updates it. Returns the server's representation of the nodevolSet, and an error, if there is any.
func (c *nodevolSets) Update(ctx context.Context, nodevolSet *v1alpha1.NodevolSet, opts v1.UpdateOptions) (result *v1alpha1.NodevolSet, err error) {
	result = &v1alpha1.NodevolSet{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("nodevolsets").
		Name(nodevolSet.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(nodevolSet).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *nodevolSets) UpdateStatus(ctx context.Context, nodevolSet *v1alpha1.NodevolSet, opts v1.UpdateOptions) (result *v1alpha1.NodevolSet, err error) {
	result = &v1alpha1.NodevolSet{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("nodevolsets").
		Name(nodevolSet.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(nodevolSet).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the nodevolSet and deletes it. Returns an error if one occurs.
func (c *nodevolSets) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("nodevolsets").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *nodevolSets) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("nodevolsets").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched nodevolSet.
func (c *nodevolSets) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NodevolSet, err error) {
	result = &v1alpha1.NodevolSet{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("nodevolsets").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
