/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppClusterPeeringLister helps list NetAppClusterPeerings.
// All objects returned here must be treated as read-only.
type NetAppClusterPeeringLister interface {
	// List lists all NetAppClusterPeerings in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppClusterPeering, err error)
	// NetAppClusterPeerings returns an object that can list and get NetAppClusterPeerings.
	NetAppClusterPeerings(namespace string) NetAppClusterPeeringNamespaceLister
	NetAppClusterPeeringListerExpansion
}

// netAppClusterPeeringLister implements the NetAppClusterPeeringLister interface.
type netAppClusterPeeringLister struct {
	indexer cache.Indexer
}

// NewNetAppClusterPeeringLister returns a new NetAppClusterPeeringLister.
func NewNetAppClusterPeeringLister(indexer cache.Indexer) NetAppClusterPeeringLister {
	return &netAppClusterPeeringLister{indexer: indexer}
}

// List lists all NetAppClusterPeerings in the indexer.
func (s *netAppClusterPeeringLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppClusterPeering, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppClusterPeering))
	})
	return ret, err
}

// NetAppClusterPeerings returns an object that can list and get NetAppClusterPeerings.
func (s *netAppClusterPeeringLister) NetAppClusterPeerings(namespace string) NetAppClusterPeeringNamespaceLister {
	return netAppClusterPeeringNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppClusterPeeringNamespaceLister helps list and get NetAppClusterPeerings.
// All objects returned here must be treated as read-only.
type NetAppClusterPeeringNamespaceLister interface {
	// List lists all NetAppClusterPeerings in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppClusterPeering, err error)
	// Get retrieves the NetAppClusterPeering from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppClusterPeering, error)
	NetAppClusterPeeringNamespaceListerExpansion
}

// netAppClusterPeeringNamespaceLister implements the NetAppClusterPeeringNamespaceLister
// interface.
type netAppClusterPeeringNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppClusterPeerings in the indexer for a given namespace.
func (s netAppClusterPeeringNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppClusterPeering, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppClusterPeering))
	})
	return ret, err
}

// Get retrieves the NetAppClusterPeering from the indexer for a given namespace and name.
func (s netAppClusterPeeringNamespaceLister) Get(name string) (*v1alpha1.NetAppClusterPeering, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappclusterpeering"), name)
	}
	return obj.(*v1alpha1.NetAppClusterPeering), nil
}
