/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
)

// NetAppServiceLevelLister helps list NetAppServiceLevels.
// All objects returned here must be treated as read-only.
type NetAppServiceLevelLister interface {
	// List lists all NetAppServiceLevels in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppServiceLevel, err error)
	// NetAppServiceLevels returns an object that can list and get NetAppServiceLevels.
	NetAppServiceLevels(namespace string) NetAppServiceLevelNamespaceLister
	NetAppServiceLevelListerExpansion
}

// netAppServiceLevelLister implements the NetAppServiceLevelLister interface.
type netAppServiceLevelLister struct {
	indexer cache.Indexer
}

// NewNetAppServiceLevelLister returns a new NetAppServiceLevelLister.
func NewNetAppServiceLevelLister(indexer cache.Indexer) NetAppServiceLevelLister {
	return &netAppServiceLevelLister{indexer: indexer}
}

// List lists all NetAppServiceLevels in the indexer.
func (s *netAppServiceLevelLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppServiceLevel, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppServiceLevel))
	})
	return ret, err
}

// NetAppServiceLevels returns an object that can list and get NetAppServiceLevels.
func (s *netAppServiceLevelLister) NetAppServiceLevels(namespace string) NetAppServiceLevelNamespaceLister {
	return netAppServiceLevelNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// NetAppServiceLevelNamespaceLister helps list and get NetAppServiceLevels.
// All objects returned here must be treated as read-only.
type NetAppServiceLevelNamespaceLister interface {
	// List lists all NetAppServiceLevels in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NetAppServiceLevel, err error)
	// Get retrieves the NetAppServiceLevel from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NetAppServiceLevel, error)
	NetAppServiceLevelNamespaceListerExpansion
}

// netAppServiceLevelNamespaceLister implements the NetAppServiceLevelNamespaceLister
// interface.
type netAppServiceLevelNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all NetAppServiceLevels in the indexer for a given namespace.
func (s netAppServiceLevelNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.NetAppServiceLevel, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NetAppServiceLevel))
	})
	return ret, err
}

// Get retrieves the NetAppServiceLevel from the indexer for a given namespace and name.
func (s netAppServiceLevelNamespaceLister) Get(name string) (*v1alpha1.NetAppServiceLevel, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("netappservicelevel"), name)
	}
	return obj.(*v1alpha1.NetAppServiceLevel), nil
}
